org.apache.commons.math.linear

## Interface DecompositionSolver

All Known Implementing Classes:
  CholeskyDecompositionImpl.Solver, EigenDecompositionImpl.Solver, LUDecompositionImpl.Solver, QRDecompositionImpl.Solver, SingularValueDecompositionImpl.Solver

    public interface DecompositionSolver

Interface handling decomposition algorithms that can solve A × X = B.

Decomposition algorithms decompose an A matrix has a product of several specific matrices from which they can solve A × X = B in least squares sense: they find X such that ||A × X - B|| is minimal.

Some solvers like `LUDecomposition` can only find the solution for square matrices and when the solution is an exact linear solution, i.e. when ||A × X - B|| is exactly 0. Other solvers can also find solutions with non-square matrix A and with non-null minimal norm. If an exact linear solution exists it is also the minimal norm solution.

Since:
  2.0
Version:
  $Revision: 811685 $ $Date: 2009-09-05 19:36:48 +0200 (sam. 05 sept. 2009) $

### Method Summary

Methods
`RealMatrix` `getInverse()` Get the inverse (or pseudo-inverse) of the decomposed matrix.
`boolean` `isNonSingular()` Check if the decomposed matrix is non-singular.
`double[]` `solve(double[] b)` Solve the linear equation A × X = B for matrices A.
`RealMatrix` `solve(RealMatrix b)` Solve the linear equation A × X = B for matrices A.
`RealVector` `solve(RealVector b)` Solve the linear equation A × X = B for matrices A.

### Method Detail

#### solve

    double[] solve(double[] b)
                   throws IllegalArgumentException,
                          InvalidMatrixException

Solve the linear equation A × X = B for matrices A.

The A matrix is implicit, it is provided by the underlying decomposition algorithm.

Parameters:
  `b` - right-hand side of the equation A × X = B
Returns:
  a vector X that minimizes the two norm of A × X - B
Throws:
  `IllegalArgumentException` - if matrices dimensions don't match
  `InvalidMatrixException` - if decomposed matrix is singular

#### solve

    RealVector solve(RealVector b)
                     throws IllegalArgumentException,
                            InvalidMatrixException

Solve the linear equation A × X = B for matrices A.

The A matrix is implicit, it is provided by the underlying decomposition algorithm.

Parameters:
  `b` - right-hand side of the equation A × X = B
Returns:
  a vector X that minimizes the two norm of A × X - B
Throws:
  `IllegalArgumentException` - if matrices dimensions don't match
  `InvalidMatrixException` - if decomposed matrix is singular

#### solve

    RealMatrix solve(RealMatrix b)
                     throws IllegalArgumentException,
                            InvalidMatrixException

Solve the linear equation A × X = B for matrices A.

The A matrix is implicit, it is provided by the underlying decomposition algorithm.

Parameters:
  `b` - right-hand side of the equation A × X = B
Returns:
  a matrix X that minimizes the two norm of A × X - B
Throws:
  `IllegalArgumentException` - if matrices dimensions don't match
  `InvalidMatrixException` - if decomposed matrix is singular

#### isNonSingular

    boolean isNonSingular()

Check if the decomposed matrix is non-singular.

Returns:
  true if the decomposed matrix is non-singular

#### getInverse

    RealMatrix getInverse()
                          throws InvalidMatrixException

Get the inverse (or pseudo-inverse) of the decomposed matrix.

Returns:
  inverse matrix
Throws:
  `InvalidMatrixException` - if decomposed matrix is singular